package com.pfc.Actividades;

import java.io.File;
import java.util.ArrayList;
import java.util.List;
import android.app.AlertDialog;
import android.app.Dialog;
import android.app.ProgressDialog;
import android.content.Context;
import android.content.DialogInterface;
import android.content.Intent;
import android.content.SharedPreferences;
import android.location.Location;
import android.location.LocationListener;
import android.location.LocationManager;
import android.net.Uri;
import android.os.Bundle;
import android.os.Handler;
import android.os.Looper;
import android.os.Message;
import android.preference.PreferenceManager;
import android.provider.Settings;
import android.util.Log;
import android.view.LayoutInflater;
import android.view.Menu;
import android.view.MenuItem;
import android.view.SubMenu;
import android.view.View;
import android.view.View.OnClickListener;
import android.widget.ImageView;
import android.widget.TextView;
import android.widget.Toast;

import com.pfc.Actividades.R;
import com.pfc.Actividades.Rutas.IServicioLocalizacion;
import com.pfc.Actividades.Rutas.ServicioLocalizacion;
import com.pfc.Actividades.Rutas.PreferenciasRuta;
import com.google.android.maps.GeoPoint;
import com.google.android.maps.MapActivity;
import com.google.android.maps.MapController;
import com.google.android.maps.MapView;
import com.google.android.maps.Overlay;
import com.pfc.Info.LibreGeoSocial;
import com.pfc.Info.Usuario;
import com.pfc.InfoCapas.CapaGenerica;

public class Home extends MapActivity implements Runnable, OnClickListener  {
	
    private ProgressDialog pd;
    
	LocationManager mLocationManager;
	Location mLocation;
	MyLocationListener mLocationListener;
	
	public static Location currentLocation = null;
	
	TextView outlat;
	TextView outlong;
	MapView mapView = null;
	ImageView imageUser;
	TextView txtUserName;
	TextView txtState;
	
	private static final int MENU_RESOURCES = Menu.FIRST + 1;
	private static final int MENU_TRACES = Menu.FIRST + 3;
	private static final int MENU_LOCATION = Menu.FIRST + 5;
	private static final int MENU_LOCATION_UPDATE = Menu.FIRST + 6;
	private static final int MENU_LOCATION_PUBLISH = Menu.FIRST + 7;
	private static final int MENU_LOCATION_CONFIG = Menu.FIRST + 8;
	private static final int MENU_LOCATION_OTHERS = Menu.FIRST + 9;	
	private static final int MENU_SETTINGS = Menu.FIRST + 10;
	private static final int MENU_AUGMENTED_REALITY = Menu.FIRST + 11;
	private static final int MENU_ABOUT = Menu.FIRST + 12;
	private static final int MENU_AR= Menu.FIRST + 13;
	private static final int DIALOG_ABOUT = 2;
	private static final int REQUEST_PREFERENCES = 1;	
	
	private String LocationType;
	
	private GeoPoint geoPoint;
	
	private Usuario user;

		
	protected void onCreate(Bundle savedInstanceState) {
		
		super.onCreate(savedInstanceState);
 
    //    setContentView(R.layout.home);
        
        imageUser = (ImageView)this.findViewById(R.id.imgUser);

        txtUserName = (TextView) this.findViewById(R.id.lbName);
        txtState = (TextView) this.findViewById(R.id.lbState);
        
                        
        user = LibreGeoSocial.getInstance().getInfoUser(true, null); 
        
        if ( user != null){
        		imageUser.setImageBitmap(user.getAvatarBitmap());
        			
        	// Save the last known location
        	ServicioLocalizacion.setLastKnownLocation(user.getLocation());
        	currentLocation = user.getLocation();
        
        	txtUserName.setText (user.getName());
        	txtState.setText(user.getState());
        } else {
        	Location auxLocation = new Location ("null");
        	auxLocation.setLatitude(0);
        	auxLocation.setLongitude(0);
        	auxLocation.setAltitude(0);
        	
        	currentLocation = auxLocation;
        	txtUserName.setText ("Annonymous");
        }
        
        showMap();
		
		ServicioLocalizacion.registerLocationListener ( new IServicioLocalizacion () {
			
			public void updateCurrentLocation(Location loc) {
			                
                setCurrentLocation(loc);
                showMap();
			}

		});
    }
    
	protected void onResume(){
		super.onResume();
			
		setCurrentLocation(ServicioLocalizacion.getCurrentLocation());
		showMap();
	}
	
	
    @Override
    public void onDestroy() 
	{
    	SharedPreferences sharedPreferences = PreferenceManager.getDefaultSharedPreferences(this);
		
		// location service status
		boolean active = sharedPreferences.getBoolean (PreferenciasRuta.KEY_LOCATION_SERVICE, false);
		
		if (!active)
		{		
	    	// Stop Location Service
	    	stopService(new Intent(this,ServicioLocalizacion.class));	
		}	
		deleteFiles();  	
    	super.onDestroy();
	}
	
    private void deleteFiles() {
    	  	
		String tmp_path = getResources().getString(R.string.tmp_path);
        File dir = new File(tmp_path);

        String[] children = dir.list();
        if (children != null) {
                for (int i=0; i<children.length; i++) {
                        String filename = children[i];
                        File f = new File(tmp_path + filename);
                        if (f.exists()) {
                                f.delete();
                        }
                }
        }
    }
    
    
    private void setCurrentLocation(Location loc) {
    	currentLocation = loc;	
    	
    	LibreGeoSocial.getInstance().setUserPosition(loc.getLatitude(), 
    												 loc.getLongitude(),
    												 loc.getAltitude());
    	if (user != null){
    		user.setLatitude(loc.getLatitude());
    		user.setLongitude(loc.getLongitude());
    	}
    }
    
	public void onClick(View arg0) {
		
		if ( ServicioLocalizacion.getLocProvider()==LocationManager.GPS_PROVIDER && getGPSStatus()==false)
		{
			Intent settingsIntent = new Intent(android.provider.Settings.ACTION_LOCATION_SOURCE_SETTINGS);
			settingsIntent.setFlags(Intent.FLAG_ACTIVITY_NEW_TASK | Intent.FLAG_ACTIVITY_RESET_TASK_IF_NEEDED);
			this.startActivityForResult(settingsIntent, 0);
		}
		else
			writeSignalGPS();
		
	}
	
	
	private boolean getGPSStatus()
	{
	    String allowedLocationProviders =
	        Settings.System.getString(getContentResolver(),
	        Settings.System.LOCATION_PROVIDERS_ALLOWED);
	 
	    if (allowedLocationProviders == null) {
	        allowedLocationProviders = "";
	    }
	 
	    return allowedLocationProviders.contains(LocationManager.GPS_PROVIDER);
	}   
	 
    
    private void writeSignalGPS() {
    	
		Toast.makeText(getBaseContext(), 
				   "Trying to get your location ...",
				   Toast.LENGTH_LONG).show();
		
		Location auxLocation = ServicioLocalizacion.getLastKnowLocation();
		
		if (auxLocation!=null)
		{
			setCurrentLocation(auxLocation);
			showMap();
		}
    }
    
    private void showMap()
    {
    	
    	if (mapView == null)
    		mapView = (MapView) findViewById(R.id.myMapView);
    	 
		
    	mapView.setBuiltInZoomControls(true); 
    	
        MapController mapControl = mapView.getController();
        
        geoPoint = new GeoPoint(  (int) (currentLocation.getLatitude() * 1000000), 
        						  (int) (currentLocation.getLongitude() * 1000000));
        mapControl.setZoom(17);
        mapControl.animateTo(geoPoint);
        
	    mapView.setClickable(true);
        
    }
 
    
	protected void onActivityResult (int requestCode, int resultCode, Intent data) {	 
		
		switch (requestCode) { 
		
	    	case REQUEST_PREFERENCES:
	    				
	    		// Stop Location Service
	        	stopService(new Intent(this,ServicioLocalizacion.class));
	    		
	    		/* Start location service */
	    		startService(new Intent(this,ServicioLocalizacion.class));	
	    		
	    		break;
		}
	}	
    
	@Override
	protected boolean isRouteDisplayed() {
		// TODO Auto-generated method stub
		return false;
	} 
	
	public void run() {
    	
		mLocationManager = (LocationManager)getSystemService(Context.LOCATION_SERVICE);
		
		if (mLocationManager.isProviderEnabled(ServicioLocalizacion.getLocProvider())) {
			
			Looper.prepare();
			
			mLocationListener = new MyLocationListener();
			
			mLocationManager.requestLocationUpdates(
					LocationType, 0, 0, mLocationListener);
			
			Looper.loop(); 
			Looper.myLooper().quit(); 
			
		} else {
			
			
            Toast.makeText(getBaseContext(), 
                    getString(R.string.gps_signal_not_found), 
                    Toast.LENGTH_LONG).show();
            
		}
	}
	
    
	private Handler handler = new Handler() {
		@Override
		public void handleMessage(Message msg) {
			
			pd.dismiss();
			
			mLocationManager.removeUpdates(mLocationListener);
	    	if (currentLocation!=null) {
	    		showMap();	    		
	    	}
		}
	};
	
	
    private class MyLocationListener implements LocationListener 
    {

        public void onLocationChanged(Location loc) {
            if (loc != null) {
                Toast.makeText(getBaseContext(), 
                    getResources().getString(R.string.gps_signal_found), 
                    Toast.LENGTH_LONG).show();
                setCurrentLocation(loc);
                handler.sendEmptyMessage(0);
            }
        }


        public void onProviderDisabled(String provider) {
            // TODO Auto-generated method stub
        }


        public void onProviderEnabled(String provider) {
            // TODO Auto-generated method stub
        }


        public void onStatusChanged(String provider, int status, 
            Bundle extras) {
            // TODO Auto-generated method stub
        }
    } 
}
