package com.pfc.Actividades;

import java.io.File;
import java.util.ArrayList;
import android.app.AlertDialog;
import android.app.Dialog;
import android.app.ListActivity;
import android.app.ProgressDialog;
import android.content.Context;
import android.content.DialogInterface;
import android.content.Intent;
import android.content.SharedPreferences;
import android.graphics.Bitmap;
import android.location.Location;
import android.location.LocationListener;
import android.location.LocationManager;
import android.os.Bundle;
import android.os.Handler;
import android.os.Looper;
import android.os.Message;
import android.preference.PreferenceManager;
import android.provider.Settings;
import android.util.Log;
import android.view.LayoutInflater;
import android.view.Menu;
import android.view.MenuItem;
import android.view.View;
import android.view.ViewGroup;
import android.widget.BaseAdapter;
import android.widget.ImageView;
import android.widget.ListView;
import android.widget.TextView;
import android.widget.Toast;

import com.pfc.Actividades.R;
import com.pfc.Actividades.Rutas.IServicioLocalizacion;
import com.pfc.Actividades.Rutas.ServicioLocalizacion;
import com.pfc.Actividades.Rutas.PreferenciasRuta;
import com.pfc.Info.LibreGeoSocial;
import com.pfc.InfoCapas.CapaGenerica;
import com.pfc.Utilidades.MapaBit;



public class ListaCapas extends ListActivity {

	private LayerAdapter mAdapter;
	private static int layerSize;	
	private static ArrayList<CapaGenerica> mLayerList = null;
	
    private ProgressDialog pd;
	LocationManager mLocationManager;
	Location mLocation;
	private String LocationType;
	public static Location currentLocation = null;
	
	public void onCreate(Bundle savedInstanceState) {

		// Init
		super.onCreate(savedInstanceState);
		Log.e("LAYERLIST","Aqui empieza-OnCreate-1");
		
		// Mete la url donde viene la informacion de los layers a cargar (youtube,panoramio...)
		LibreGeoSocial.getInstance().setUrl(getString(R.string.urlServer));
        LibreGeoSocial.getInstance().setFormat("JSON");
        
        // Aqui construye haciendo uso del servidor, la lista con los layers a cargar (panoramio...)
		mLayerList = LibreGeoSocial.getInstance().getLayerList();//mlayerlist es un array de layers(panoramio,ettc.)
		layerSize = mLayerList.size();
		
 		// Adapter for ListView
        mAdapter = new LayerAdapter(this);
        setListAdapter(mAdapter);
        
        /* Start location service */
		startService(new Intent(this,ServicioLocalizacion.class));		
		
		ServicioLocalizacion.registerLocationListener ( new IServicioLocalizacion () {
			
			public void updateCurrentLocation(Location loc) {
			       
				//ServicioLocalizacion.setCurrentLocation(loc);
				Toast.makeText(getBaseContext(), 
	                    "Localizacion OK ", 
	                    Toast.LENGTH_LONG).show();
			}

		});	
	}


	@Override
    public void onDestroy() 
	{
    	SharedPreferences sharedPreferences = PreferenceManager.getDefaultSharedPreferences(this);
		
		// location service status
		boolean active = sharedPreferences.getBoolean (PreferenciasRuta.KEY_LOCATION_SERVICE, false);
		
		if (!active)
		{		
	    	// Stop Location Service
	    	stopService(new Intent(this,ServicioLocalizacion.class));	
		}
		
    	super.onDestroy();
	}
	
    protected void onListItemClick(ListView l, View v, int position, long id) {
    	
    	Log.e("LAYERLIST","onListItemClick - 3");
        
    	if (LibreGeoSocial.getInstance().getLocation() != null){
    		Intent IntentLGS = new Intent(this, new ListaNodos().getClass() );
        	
        	CapaGenerica layer = mLayerList.get(position);
        	layer.setRadius(5.0);
    		IntentLGS.putExtra ("layer",layer);
    		
    		startActivity(IntentLGS);
    	} else {
    		Log.e("Location", "Please wait for a location");
    	}  	
	}
    

    public static class LayerAdapter extends BaseAdapter {

		private Context mContext;
		
		public LayerAdapter(Context c) {
            mContext = c;
        }

		public int getCount() {
			// TODO Auto-generated method stub
			return layerSize;
		}

		public Object getItem(int position) {
			// TODO Auto-generated method stub
			return position;
		}

		public long getItemId(int position) {
			// TODO Auto-generated method stub
			return position;
		}

		public View getView(int position, View convertView, ViewGroup parent) {
			// TODO Auto-generated method stub
			View view;
			 
	        if (convertView == null) {
	            // Make up a new view
	            LayoutInflater inflater = (LayoutInflater) mContext
	                    .getSystemService(Context.LAYOUT_INFLATER_SERVICE);
	            view = inflater.inflate(R.layout.layer_list, null);
	        } else {
	            // Use convertView if it is available
	            view = convertView;
	        }
			
	        ImageView img = (ImageView) view.findViewById(R.id.image);
	        TextView title = (TextView) view.findViewById(R.id.title);
	        TextView description = (TextView) view.findViewById(R.id.description);
	        ImageView arrow = (ImageView) view.findViewById(R.id.arrow);
	  

	        img.setImageBitmap(mLayerList.get(position).getIcon());
        	title.setText(mLayerList.get(position).getNameLayer());
        	description.setText(mLayerList.get(position).getDescription());
        	
	        arrow.setImageResource(R.drawable.bclose);
	        
	        return view;
		}
	}
}
