package com.pfc.Actividades.RealidadAumentada;

import java.util.ArrayList;
import android.app.Activity;
import android.content.SharedPreferences;
import android.graphics.Bitmap;
import android.graphics.BitmapFactory;
import android.os.Bundle;
import android.preference.PreferenceManager;
import android.util.Log;

import com.pfc.Actividades.R;
import com.pfc.Info.GeoNodo;
import com.pfc.Info.Foto;
import com.pfc.Info.Usuario;
import com.pfc.InfoCapas.CapaGenerica;
import com.pfc.Utilidades.Localizacion;

// esta clase se utiliza cuando se esta mostrando AR en la camara

public class ActividadAR extends Activity{
	
	private GestorCapa layers;
	
	private ArrayList<GeonodoAR> resources_list = null;
	private CapaGenerica mylayer = null;
	private float[] location = new float[3]; 
	private boolean is_threshold;
	private float threshold;
	private boolean use_height = true;
	
    protected void onCreate(Bundle savedInstanceState) {
        super.onCreate(savedInstanceState);
        
        layers = new GestorCapa(this);
//        if(loadMainHeightPreference())
  //      	loadThresholdPreferences();
    }
   
   /* 
    protected boolean loadMainHeightPreference(){
    	SharedPreferences sharedPreferences = PreferenceManager.getDefaultSharedPreferences(this);
		use_height = !sharedPreferences.getBoolean(ARPreferences.KEY_NOT_HEIGHT, false);
		return use_height;
    }
    */
    
    /*
    protected void loadThresholdPreferences(){
		SharedPreferences sharedPreferences = PreferenceManager.getDefaultSharedPreferences(this);
		is_threshold = sharedPreferences.getBoolean(ARPreferences.KEY_IS_DIST_FILTER, false);
		threshold = Float.parseFloat(sharedPreferences.getString(ARPreferences.KEY_DIST_FILTER, "0"));
    }
    */
    
    
    protected void setResourcesList(ArrayList<GeonodoAR> resources_list){
    	this.resources_list = resources_list;
    }
    
    protected void setMyLayer(CapaGenerica mylayer){
    	this.mylayer = mylayer;
    }
    
    protected void useHeight(boolean use_height){
    	this.use_height = use_height;
    }
    
    protected boolean isUsingHeight(){
    	return use_height;
    }
    
    protected ArrayList<GeonodoAR> getResourcesList(){
    	return resources_list;
    }
    
    protected CapaGenerica getMyLayer(){
    	return mylayer;
    }
    
    protected void setLocation(float[] location){
    	this.location = location.clone();
    }
    
    protected float[] getLocation(){
    	return location;
    }
    
    protected GestorCapa getLayers(){
    	return layers;
    }
    
    protected void updateHeights(){
    	int length = resources_list.size();
    	for(int i = (length - 1); i > -1; i--){
    		GeoNodo resource = resources_list.get(i).getGeoNode();
    //		if(resource.getAltitude() < 0)
    //			resource.setAltitude((float)AltitudeManager.getAltitudeFromLatLong(
    //					(float)(double)resource.getLatitude(), 
    //					(float)(double)resource.getLongitude()));
    	}
    }
    
	protected void refreshResourceDrawns(float[] values){
		if(resources_list==null)
			return;
		if(resources_list.isEmpty())
			return;

		int sizeList = resources_list.size();

		GeonodoAR resource;
		for(int i=sizeList; i>0; i--){
			resource = resources_list.get(i-1);
			
			if(resource == null)
				return;
			
			float distance = resource.distanceToResource(location);
			float res_azimuth = resource.azimuthToResource(location);
			float azimuth_user = Localizacion.calculateAzimuthFromUser(GestorBrujula.getAzimuth(values),res_azimuth);

			float[] resource_loc = {(float)(double)resource.getGeoNode().getLatitude(), (float)(double)resource.getGeoNode().getLongitude()};
			float azimuth_camera = Localizacion.calculateAngleToCam(location, resource_loc, GestorBrujula.getAzimuth(values), azimuth_user, Localizacion.DEV_DISTANCE);

			float res_roll;
			if(!use_height || (is_threshold && (distance > threshold)))
				res_roll = 90;
			else
				res_roll = resource.rollToResource(resource.distanceToResource(location));

			float elevation = Localizacion.calculateRollFromUser(GestorBrujula.getElevation(values), res_roll);

			if (!resource.isLoaded()){
				//Initialize the draw element
				String name = "Unamed";
				Bitmap icon = null;
				if ( Foto.class.isInstance(resource.getGeoNode()))    	
				{
					Foto node = (Foto) resource.getGeoNode();
					name = node.getName();
					icon = BitmapFactory.decodeResource(getResources(), R.drawable.camera_38);
				}
				else if ( Usuario.class.isInstance(resource.getGeoNode()) )
				{
					Usuario node = (Usuario) resource.getGeoNode();
					name = node.getUsername();
				}

				resource.createDrawn(this, name, icon);
			}

			resource.setDrawnValues(azimuth_camera, res_azimuth, elevation, distance);
			if(!resource.isLoaded()){
				resource.setLoaded(true);
			}

			if(!layers.isChildInResourcesList(resource.getDrawn()))
				layers.addResourceElement(resource.getDrawn(), null);
			resource.invalidateDrawn();
		}
	}
}