package com.pfc.Actividades.Rutas;

import java.util.ArrayList;
import android.app.NotificationManager;
import android.app.Service;
import android.content.Context;
import android.content.Intent;
import android.content.SharedPreferences;
import android.content.SharedPreferences.Editor;
import android.location.Location;
import android.location.LocationListener;
import android.location.LocationManager;
import android.os.Bundle;
import android.os.IBinder;
import android.preference.PreferenceManager;
import android.util.Log;

import com.pfc.Info.LibreGeoSocial;

// esta clase es utilizada justo antes de salir Panoramio, para obtener nuestra 
// localizacion.

public class ServicioLocalizacion extends Service {
	
	
	private static ArrayList <IServicioLocalizacion> arrayLocationListener = 
												new ArrayList<IServicioLocalizacion>();	
	private static String TraceName;
	private static String LocProvider;	
	private static Location currentLocation = null;	
	public static Location lastKnownLocation = null;
	
	private NotificationManager mNM;
	
	private static LocationManager mLocationManager;
	private RoutePositionListener mLocationListener = null;
	
	// Location Unit (seconds:1 or minutes:60), by default: seconds.
	static Integer LocationUnit = null;
	
	// Location Periodic in seconds, by default 2 minutes.
	static Integer LocationPeriodic = null; 
	
	// Minimum distance of gps refresh
	static Integer MinimumDistance = null;

	private static ArrayList<Location> points = new ArrayList<Location>();
	
	@Override
	public IBinder onBind(Intent arg0) {
		// TODO Auto-generated method stub
		return null;
	}
	
   @Override
    public void onCreate() {
	   startService();
	   
    }

   @Override
   public void onDestroy() {
       if (mLocationListener != null)
    	   mLocationManager.removeUpdates(mLocationListener);
   }
   
   public static void initRoute()
   {
	   points.clear();
   }
   
   public static void setProvider (String provider)
   {
	   LocProvider = provider;   
   }
   
   
   public static Integer registerLocationListener (IServicioLocalizacion l)
   {
	   arrayLocationListener.add(l);
	   return arrayLocationListener.size();
   }
   
   public static void  unRegisterLocationListener (Integer pos)
   {
	   arrayLocationListener.remove(pos-1);
   }
   
   public static void setTraceName (String name) 
   {
	   TraceName = name;	   
   }
   
   public static Location getCurrentLocation ()
   {	
	   if (currentLocation == null)
		   return  mLocationManager.getLastKnownLocation(LocProvider);
	   return currentLocation;
   }
   
   public static void setLastKnownLocation (Location lastKnownLocation)
   {	
	   ServicioLocalizacion.lastKnownLocation = lastKnownLocation;
   }
   
   public static Location getLastKnowLocation ()
   {
	   return mLocationManager.getLastKnownLocation(LocProvider);
   }


   public static void setCurrentLocation (Location currentLocation){
	   ServicioLocalizacion.currentLocation = currentLocation;
   }
   

    private void startService() {
    	mLocationManager = (LocationManager)getSystemService(Context.LOCATION_SERVICE);
		mLocationListener = new RoutePositionListener();
    	loadConfig();
    	
    	Log.e("LGS-Service:",LocProvider);
		mLocationManager.requestLocationUpdates( LocProvider, 
												 ((LocationPeriodic)* 1000) * LocationUnit, 
												 MinimumDistance, 
												 mLocationListener);	
    }
    
    
    private class RoutePositionListener implements LocationListener 
    {
        public void onLocationChanged(Location loc) {
        	if (loc != null) {
    			if(LocProvider.equals(LocationManager.NETWORK_PROVIDER))
   // 				loc.setAltitude(AltitudeManager.getAltitudeFromLatLong(
    //						(float)loc.getLatitude(), (float)loc.getLongitude()));
    			
    			// Save the current location
				currentLocation = loc;						
 
        		if (arrayLocationListener.size() > 0)
        		{      			
        			LibreGeoSocial.getInstance().setUserPosition (loc.getLatitude(), 
        														  loc.getLongitude(),
        														  loc.getAltitude());
 
        			for (int i=0; i<arrayLocationListener.size(); i++)
        				arrayLocationListener.get(i).updateCurrentLocation(loc);        						        				
        		}
            }           
        }


        public void onProviderDisabled(String provider) {
            // TODO Auto-generated method stub
        }


        public void onProviderEnabled(String provider) {
            // TODO Auto-generated method stub
        }


        public void onStatusChanged(String provider, int status, 
            Bundle extras) {
            // TODO Auto-generated method stub
        }
    }
    
    public static String getLocProvider()
    {
    	return LocProvider;
    }
    
    private void loadConfig ()
	{
		SharedPreferences sharedPreferences = PreferenceManager.getDefaultSharedPreferences(this);
		Editor editor = sharedPreferences.edit();
		String s_provider = sharedPreferences.getString(PreferenciasRuta.KEY_LOCATION_PROVIDERS, null);
			
		if (s_provider == null)
		{
			LocProvider = LocationManager.NETWORK_PROVIDER;
			editor.putString (PreferenciasRuta.KEY_LOCATION_PROVIDERS, LocProvider);
		}
		else
		{
			if (s_provider.equals("gps"))
				LocProvider = LocationManager.GPS_PROVIDER;
			
			else		
				LocProvider = LocationManager.NETWORK_PROVIDER;
		}

		String s_unit = sharedPreferences.getString(PreferenciasRuta.KEY_LOCATION_UNITS, null);
		
		if (s_unit == null)
		{
			LocationUnit = 60;
			editor.putString(PreferenciasRuta.KEY_LOCATION_UNITS, "60");
		}
		else
		{			
			Integer unit = Integer.valueOf(s_unit);	
			LocationUnit = unit;
		}

		String s_periodic = sharedPreferences.getString(PreferenciasRuta.KEY_LOCATION_PERIODIC, null);
		
		if (s_periodic==null)
		{
			LocationPeriodic = 2;
			editor.putString(PreferenciasRuta.KEY_LOCATION_PERIODIC, "2");
		}
		else
		{
			Integer periodic = Integer.valueOf(s_periodic);
			LocationPeriodic = periodic;
		}

		String s_minDistance = sharedPreferences.getString(PreferenciasRuta.KEY_LOCATION_DISTANCE, null);
		if (s_minDistance == null)
		{
			MinimumDistance = 10;
			editor.putString(PreferenciasRuta.KEY_LOCATION_DISTANCE, "20");
		}
		else
		{			
			Integer minDistance = Integer.valueOf(s_unit);				
			MinimumDistance = minDistance;
		}	
		editor.commit();	
	}
}