package com.pfc.InfoCapas;

import java.io.Serializable;
import java.util.ArrayList;
import java.util.Collections;
import android.graphics.Bitmap;
import android.os.Handler;
import android.util.Log;

import com.pfc.Info.GeoNodo;
import com.pfc.Info.ComparadorGeoNodo;
import com.pfc.Info.LibreGeoSocial;

public class CapaGenerica extends GeoNodo implements Serializable {

	private static final long serialVersionUID = -6501648066678686473L;
	
	private String mPattern;
	private Integer mPage;
	
	private String mLayer_type, mName, mDescription;
	private Boolean mWriteable, mFree;
	
	protected ArrayList<GeoNodo> mArrayNodes = new ArrayList<GeoNodo>();
	private ArrayList<Categoria> mCategories = new ArrayList<Categoria>();
	
	public CapaGenerica (Integer id, String layer_type, String name, String description, String since,
			Double latitude, Double longitude, Double altitude, Double radius, String since_position){
		
		super(id, latitude, longitude, altitude, radius, since, since_position );
		
		mWriteable = false;
		mLayer_type = layer_type;
		mName = name;
		mFree = true;
		mDescription = description;
	}
	
	public boolean getWriteable (){
		return mWriteable;
	}
	public void setWriteable(Boolean mWriteable){
		this.mWriteable = mWriteable;
	}
	public String getNameLayer() {
		return mName;
	}
	public void setNameLayer(String mName) {
		this.mName = mName;
	}
	public String getPattern() {
		return mPattern;
	}
	public void setPattern(String mPattern) {
		this.mPattern = mPattern;
	}
	
	public ArrayList<GeoNodo> getNodes()
	{
		return mArrayNodes;
	}
	
	public void setNodes ( ArrayList<GeoNodo> nodes )
	{
		mArrayNodes = nodes;
	}
	public String getDescription(){
		return mDescription;
	}
	
	public Bitmap getIcon ()
	{
		return LibreGeoSocial.getInstance().getBitmap("layer/" + getId().toString() + "/icon/" );
	}

	public void resetPagination()
	{
		mPage=1;
	}
	
	public void nextPage()
	{
		mPage++;
	}
	
	public void previousPage()
	{
		if (mPage>1)
			mPage--;
	}
	
	public Integer getCurrentPage()
	{
		return mPage;
	}
	
	public Thread getThreadtoUpdate(final Handler hNotification,  final String[] categories) 
	{
		final Integer elems = 4;
		
		Log.e("LibreGeoSocialLayer","getThreadtoUpdate");
		
		Thread th = new Thread()
		{
        	public void run()
        	{
        		if (CapaGenerica.this.getId() == -1){
        			//If the layer is local
        			try {
                        sleep(1000);
                        hNotification.sendEmptyMessage(0);

                    } catch (InterruptedException e) {
                        Log.e ("NodeListLayer: ", e.getMessage().toString() );
                    }
        		}else{
        			final int size = categories.length;
        			ArrayList<GeoNodo> auxArray = new ArrayList<GeoNodo>();
        		
        			for (int i = 0; i < size; i++){
        				if (categories[i] != "x")
        					auxArray.addAll (LibreGeoSocial.getInstance().getLayerNodes (CapaGenerica.this.getId(), 
        																	 getPattern(), 
        																	 categories[i], 
        																	 getRadius(),
        																	 getCurrentPage(),
        																	 elems));
        			}
        		
        			if (! auxArray.isEmpty() )
        			{
        				ComparadorGeoNodo comparator = new ComparadorGeoNodo();
        				Collections.sort(auxArray, comparator);
        			}
        		
        			mArrayNodes = auxArray;
        		
        			hNotification.sendEmptyMessage(0);
        		}
        	}
		};
		  
		return th;
	}
	
	public String[] getCategories (String take)
	{
		if (CapaGenerica.this.getId() == -1){
			return null;
		}
		
		mCategories = LibreGeoSocial.getInstance().parseCategories(CapaGenerica.this.getId());
		Integer size = mCategories.size();
		String[] list = new String[size];
		if (take.equalsIgnoreCase("id"))
			for (int i = 0; i < size; i++){
				list[i] = mCategories.get(i).getId().toString();				
			}
		else if (take.equals("name"))
			for (int i = 0; i < size; i++){
				list[i] = mCategories.get(i).getName();				
			}
		return list;
	}
}
