package com.pfc.Superposicion;

import android.graphics.Canvas;
import android.graphics.Point;
import android.graphics.drawable.Drawable;
import android.util.Log;
import com.google.android.maps.GeoPoint;
import com.google.android.maps.MapView;
import com.google.android.maps.Overlay;
import com.google.android.maps.Projection;

// Esta clase es utilizada para superponer el mapa de la localizacion del punto que 
// estemos localizando.. Dibuja ese mapa.

public class SuperposicionMapa extends Overlay {
	
	   private Drawable mMarker;
	   private int mMarkerXOffset;
	   private int mMarkerYOffset;
	   
	   private GeoPoint mGeoPoint;
	   
	   public void setGeoPoint (GeoPoint geoPoint)
	   {
		   mGeoPoint = geoPoint;			   
	   }
	   
	   public void setDrawable(Drawable draw)
	   {
		   mMarker = draw;
	   }
	   
	   @Override
	   public void draw(Canvas canvas, MapView mapView, boolean shadow) {
         if (!shadow) {
         
	   	       final int intrinsicWidth = mMarker.getIntrinsicWidth();
	   	       final int intrinsicHeight = mMarker.getIntrinsicHeight();
	   	       mMarker.setBounds(0, 0, intrinsicWidth, intrinsicHeight);
	   	        
	   	       mMarkerXOffset = -(intrinsicWidth / 2);
	   	       mMarkerYOffset = -intrinsicHeight;
	       
             Point point2 = new Point();
             Projection p = mapView.getProjection();
             p.toPixels(mGeoPoint, point2);

             super.draw(canvas, mapView, shadow);
             drawAt(canvas, mMarker, point2.x + mMarkerXOffset, point2.y + mMarkerYOffset, shadow);
         }
	   }
 }
