package com.pfc.SuperposicionesAR;

// esta clase es usada para ejecutar la camara una vez piquemos sobre algun nodo,
// por ejemplo, puente de triana.
//Esta clase, que hereda de la clase SurfaceView de Android, se encarga de definir
//la superficie que contiene una vista previa de la camara, la cual se utilizara como
//base de la actividad CamView.

import java.io.IOException;
import android.content.Context;
import android.hardware.Camera;
import android.util.Log;
import android.view.SurfaceHolder;
import android.view.SurfaceView;

public class CamaraPreview extends SurfaceView implements SurfaceHolder.Callback {
    private SurfaceHolder mHolder;
    private Camera mCamera;
    
    public CamaraPreview(Context context) {
        super(context);
        
        mHolder = getHolder();
        mHolder.addCallback(this);
        mHolder.setType(SurfaceHolder.SURFACE_TYPE_PUSH_BUFFERS);
    }

    public void surfaceCreated(SurfaceHolder holder) {

    	if(mCamera == null)
    		Log.e("CCCCC", "vacio");
        try {
            mCamera = Camera.open();
			mCamera.setPreviewDisplay(holder);
		} catch (IOException e) {
			// TODO Auto-generated catch block
	        mCamera.release();
			Log.e("CamaraPreview", e.toString());
		}
    }

    public void surfaceDestroyed(SurfaceHolder holder) {
        mCamera.stopPreview();
        mCamera.release();
        mCamera = null;
    }

    
    public void surfaceChanged(SurfaceHolder holder, int format, int w, int h) {
        try {
            mCamera.setPreviewDisplay(holder);
			mCamera.startPreview();
		} catch (Exception e) {
			// TODO Auto-generated catch block
	        mCamera.release();
			Log.e("CamaraPreview", e.toString());
		}
    }
}